 include "settings.inc"
  include "../ti83plus.inc"
  include "usb8x.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON
 EXTERN IPutS,IGetKey,USBSaveSP,USBInfo,SendUSBCmd,GetDescriptor,Send8PortA0,USBInfo,NotInitTXT
 EXTERN CDBuf,IPutC,PutSprite,FastCopy,DoMenu,DispHexA,USBInfoError,Start,DispError,INewLine,DriverBuf


 Var KBDRAM,32
 Var PadRAM,32
 Var PadButtons,10

Demos:
       ld     a,menuDemos
       jr     DoMenu

DemoError:
       U_CALL HostKill
       U_CALL StopLog
       call   DispError
       call   IGetKey
       jr     Demos

PadDemo:
       ld     hl,PadRAM
       ld     de,DBuf
       U_CALL PadInit
       jr     c,DemoError
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,PadButtons
       ld     d,0
PadSetupLoop:
       push   de
       push   hl
       ld     l,d
       ld     h,0
       add    hl,hl
       ld     bc,ButStringTab
       add    hl,bc
       B_CALL LdHLInd
       call   IPutS
       U_CALL PadSetup
       pop    hl
       pop    de
       jr     c,DemoError
       ld     (hl),b
       inc    hl
       ld     (hl),c
       inc    hl
       call   INewLine
       inc    d
       ld     a,5
       cp     d
       jr     nz,PadSetupLoop
       U_CALL PadStart
       B_CALL GrBufClr
       xor    a
       ld     (MouseBtn),a
       ld     a,50*2
       ld     (MouseX),a
       ld     a,32*2
       ld     (MouseY),a
       call   DispCursor

PadLoop:
       ei
       B_CALL GrBufCpy
       B_CALL GetCSC
       cp     skClear
       jr     z,MouseDone
       call   DispCursor
       call   PadUpdateCursor
       call   DispCursor
       jr     PadLoop

PadUpdateCursor:
       ld     c,0
       ld     hl,MouseY
       call   PadCheck
       jr     z,$f
       inc    (hl)
$$:
       inc    c
       call   PadCheck
       jr     z,$f
       dec    (hl)
$$:
       ld     hl,MouseX
       inc    c
       call   PadCheck
       jr     z,$f
       dec    (hl)
$$:
       inc    c
       call   PadCheck
       jr     z,$f
       inc    (hl)
$$:
       inc    c
       ld     b,0
       ld     hl,MouseBtn
       call   PadCheck
       jr     z,$f
       inc    b
$$:
       ld     (hl),b
       ret
       


PadCheck:
       push   hl
       push   bc
       ld     hl,PadButtons
       ld     b,0
       add    hl,bc
       add    hl,bc
       ld     c,(hl)
       inc    hl
       ld     a,(hl)
       ld     hl,DriverBuf
       add    hl,bc
       and    (hl)
       pop    bc
       pop    hl
       ret

       
ButStringTab:
       dw     DownTXT
       dw     UpTXT
       dw     LeftTXT
       dw     RightTXT
       dw     FireTXT
DownTXT:
       db     "Down?",0
UpTXT:
       db     "Up?",0
LeftTXT:
       db     "Left?",0
RightTXT:
       db     "Right?",0
FireTXT:
       db     "Fire?",0

SilverDemo:


       ld     de,DBuf
       U_CALL SilverInit
       jp     c,DemoError

       ld     hl,OP1+31
       ld     b,32
$$:
       ld     a,b
       dec    a
       ld     (hl),a
       dec    hl
       djnz   $b
       
       ld     hl,0
       ld     (DataCount),hl
       ld     (DataCount+2),hl
       ld     hl,TransmittingTXT

       call   IPutS
       in     a,(45h)
       ld     b,a
$$:
       in     a,(45h)
       cp     b
       jr     z,$b
       inc    a
;       inc    a
       out   (41h),a
GraphlinkLoop:
       in     a,(45h)
       ld     b,a
       in     a,(41h)
       cp     b
       jr     z,GraphlinkDone
       ld     b,20h
       ld     hl,OP1
       U_CALL SilverSend
       ld     b,0
SerialLoop:
       push   bc
       B_CALL RecAByteIO
       pop    bc
       cp     b
       jp     nz,DemoError
       inc    b
       ld     a,32
       cp     b
       jr     nz,SerialLoop
       ld     hl,(DataCount)
       ld     a,l
       and    7Fh
       ld     a,'.'
       call   z,IPutC
       ld     de,32
       add    hl,de
       ld     (DataCount),hl
       jr     nc,GraphlinkLoop
       ld     hl,(DataCount+2)
       inc    hl
       ld     (DataCount+2),hl
       jr     GraphlinkLoop
GraphlinkDone:
       B_CALL NewLine
       ld     hl,(DataCount)
       B_CALL DispHL
       ld     hl,BPSTXT
       call   IPutS
       B_CALL GetKey
       U_CALL HostKill
       jr     Demos
BPSTXT:
       db     " B/SEC",0
 Var DataCount,4

TransmittingTXT:
       db     "Transmitting",0


MSDDemo:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,UseMSDTXT
       call   IPutS
       call   IGetKey
       jr     Demos
UseMSDTXT:
       db     "Make my life    "
       db     "easier and just "
       db     "use msd8x for a "
       db     "demo.",0



KBDDemo:
       ld     hl,KBDRAM
       ld     de,DBuf
       ld     b,2h
       U_CALL KBDInit
       jr     c,DemoError
$$:
       ei
       B_CALL GetCSC
       cp     skClear
       jr     z,KBDDone
       U_CALL KBDGetKey
       jr     c,$b
       ld     a,kQuit
       cp     e
       jr     z,KBDDone
       B_CALL KeyToString
       ld     hl,keyToStrRam
       B_CALL PutPS
       jr     $b
KBDDone:
       U_CALL HostKill
       jr     Demos




 Var MouseX,1
 Var MouseY,1
 Var MouseBtn,1
 Var MouseBtnNew,1
 Var MouseXNew,1
 Var MouseYNew,1
    

MouseDemo:
       ld     a,1
       ld     de,DBuf
       U_CALL MouseInit
       jp     c,DemoError
       B_CALL GrBufClr
       xor    a
       ld     (MouseBtn),a
       ld     a,50*2
       ld     (MouseX),a
       ld     a,32*2
       ld     (MouseY),a
       call   DispCursor

MouseLoop:
       ei
       B_CALL GrBufCpy
       B_CALL GetCSC
       cp     skClear
       jr     z,MouseDone
       call   DispCursor
       ld     b,4
$$:
       push   bc
       U_CALL MouseGetKey
       call   MouseUpdateCursor
       pop    bc
       djnz   $b

       call   DispCursor
       jr     MouseLoop




MouseUpdateCursor:
       ld     a,b
       ld     (MouseBtn),a
       ld     hl,MouseX
       bit    mouseBitRight,c
       jr     z,$f
       inc    (hl)
$$:
       bit    mouseBitLeft,c
       jr     z,$f
       dec    (hl)
$$:
       ld     hl,MouseY
       bit    mouseBitDown,c
       jr     z,$f
       inc    (hl)
$$:
       bit    mouseBitUp,c
       ret    z
       dec    (hl)
       ret


MouseDone:
       call   DispCursor
       U_CALL HostKill
       jp     Demos

DispCursor:
       ld     ix,MouseSpr
       ld     a,(MouseBtn)
       or     a
       jr     z,$f
       ld     ix,SmileSpr
$$:

       ld     a,(MouseY)
       srl    a
       ld     l,a
       ld     a,(MouseX)
       srl    a
       call   PutSprite
       ret

SmileSpr:
       db     01100110b
       db     01100110b
       db     00000000b
       db     00011000b
       db     10000001b
       db     01100110b
       db     00111100b
       db     00000000b

MouseSpr:
       db     11111000b
       db     11110000b
       db     11110000b
       db     11001000b
       db     10000100b
       db     00000010b
       db     00000001b
       db     00000000b

 COMMENT ~
GetHIDReportDesc:
;Get the HID report descriptor.  Assumes device already initialized
;Input
; HL -> descriptor buf (must be big enough for config descriptor)
;Output
; B = descriptor length
; NC = success
       push   hl
       push   hl
       ld     b,descConfig
       U_CALL ReadDescriptor
       pop    hl
       jr     c,PopRetC
       ld     b,descHID
       U_CALL FindDescriptor
       jr     c,PopRetC
       ld     de,6
       add    hl,de
       ld     c,(hl)               ;Descriptor type
       inc    hl
       ld     b,(hl)               ;Descriptor length
       push   bc
       ld     hl,HIDReportDesData
       rst    20h
       pop    bc
       ld     a,c
       ld     (OP1+3),a
       ld     a,b
       ld     (OP1+6),a
       pop    de
       push   bc
       ld     c,b
       ld     hl,OP1
       ld     b,descReport
       U_CALL ReadDescriptor
       pop    bc
       ret
PopRetC:
       pop    hl
       scf
       ret

HIDReportDesData:
       db     81h,06,00,00,00,00,00,00




ReportDescDemo:
       set    appAutoScroll,(iy+appFlags)
       ld     hl,8000h
       ld     b,82h
       U_CALL SetupLog
       U_CALL HostInit       
       jp     c,USBInfoError
       ld     hl,CDBuf
       call   GetHIDReportDesc
       jp     c,USBInfoError
       ld     hl,CDBuf
$$:
       ld     a,(hl)
       call   DispHexA
       inc    hl
       djnz   $b
       call   IGetKey
       U_CALL StopLog
       jp     HIDDemos
 ~


