 include "settings.inc"
  include "../ti83plus.inc"
  include "usb8x.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON
 EXTERN IPutS,DispHexA,GetHexA,IGetKey,INewLine,MainMenu,Tools

 Var LogPage,1
 Var LogAddr,2

LogStartTool:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,LogPageTXT
       call   IPutS
       call   GetHexA
       push   af
       call   INewLine
       ld     hl,LogAddrTXT
       call   IPutS
       call   GetHexA
       push   af
       call   GetHexA
       ld     l,a
       pop    af
       ld     h,a
       pop    bc
       U_CALL SetupLog
       B_CALL NewLine
       ld     hl,LogStartTXT
       call   IPutS
       call   IGetKey
       jr     Tools
LogStartTXT:
       db     "Log Started",0
       
              

LogTool:
       call   DispLog
       jr     Tools

DispLog:
       res    appAutoScroll,(iy+appFlags)
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,LogPageTXT
       call   IPutS
       call   GetHexA
       ld     (LogPage),a
       call   INewLine
       ld     hl,LogAddrTXT
       call   IPutS
       call   GetHexA
       ld     (LogAddr+1),a
       call   GetHexA
       ld     (LogAddr),a
       call   GetLogVal
       ld     a,logSetupLog
       cp     b
       jr     nz,NoLogData
DispLogLoop:
       call   DispLogScreen
$$:
       call   IGetKey
       cp     kClear
       jr     z,DispLogDone
       cp     kQuit
       jr     z,DispLogDone
       cp     kEnter
       jr     z,LogEnter
       cp     kUp
       jr     z,LogUp
       cp     kDown
       jr     nz,$b
LogDown:
       call   GetLogVal
       ld     a,b
       cp     logLogDone
       jr     z,$b
       cp     logQuit
       jr     z,$b
       call   IncLogAddr
       jr     DispLogLoop
LogUp:
       call   GetLogVal
       ld     a,b
       cp     logSetupLog
       jr     z,$b
       call   DecLogAddr
       jr     DispLogLoop
LogEnter:
       call   GetLogVal
       ld     a,logDataStart
       cp     b
       jr     nz,$b
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,(LogAddr)
       push   hl
       inc    hl
       inc    hl
       ld     (LogAddr),hl
       call   GetLogVal
       ld     e,b
       ld     d,c
       dec    de
       dec    de
       dec    de
       dec    de                   ;Place to end loop
       inc    hl
       inc    hl
       ld     (LogAddr),hl
LogEnterLoop:
       call   GetLogVal
       ld     a,b
       call   DispHexA
       ld     a,c
       call   DispHexA
       inc    hl
       inc    hl
       ld     (LogAddr),hl
       B_CALL CpHLDE
       jr     nz,LogEnterLoop
       call   IGetKey
       pop    hl
       ld     (LogAddr),hl
       jp     DispLogLoop
DispLogDone:
       set    appAutoScroll,(iy+appFlags)

DecLogAddr:

       ld     hl,(LogAddr)
       jr     z,DecLogData
       dec    hl
       dec    hl
       dec    hl
       dec    hl
       ld     (LogAddr),hl
       call   GetLogVal
       ld     a,logDataEnd
       cp     b
       ret    nz


DecLogData:
IncLogData:
       inc    hl
       inc    hl
       ld     (LogAddr),hl
       call   GetLogVal
       ld     h,c
       ld     l,b
       ld     (LogAddr),hl
       ret


IncLogAddr:
       call   GetLogVal
       ld     a,logDataStart
       cp     b
       ld     hl,(LogAddr)
       jr     z,IncLogData
       inc    hl
       inc    hl
       inc    hl
       inc    hl
       ld     (LogAddr),hl
       ret

DispLogScreen:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,(LogAddr)
       push   hl
       ld     b,8
$$:
       push   bc
       call   GetLogVal
       ld     a,NumLogVals
       cp     b
       ld     hl,lsLogError
       jr     c,BadLogVal
       ld     l,b
       ld     h,0
       add    hl,hl
       ld     de,LogStringTable
       add    hl,de
       B_CALL LdHLInd
BadLogVal:
       call   IPutS
       ld     a,14
       ld     (curCol),a
       ld     a,c
       call   DispHexA
       ld     a,b
       cp     logLogDone
       jr     z,$f
       cp     logQuit
       jr     z,$f
       call   IncLogAddr
       pop    bc
       djnz   $b
       push   bc
$$:
       pop    bc
       pop    hl
       ld     (LogAddr),hl
       ret


GetLogVal:
;Output
; B = Log Type
; C = Log data1
; HL -> current LogAddr
       push   de
       in     a,(7)
       ld     d,a
       ld     hl,(LogAddr)
       ld     a,(LogPage)
       di
       out    (7),a
       ld     b,(hl)
       inc    hl
       ld     c,(hl)
       ld     a,d
       out    (7),a
       ei
       dec    hl
       pop    de
       ret

NoLogData:
       B_CALL NewLine
       ld     hl,NoLogDataTXT
       call   IPutS
       jp     IGetKey
NoLogDataTXT:
       db     "No Log Data",0

 COMMENT ~
logGetMaxPacketSize EQU 1
logData EQU 2
logGetClass EQU 3
logGetIDs EQU 4
logReadDescriptor EQU 5
logQuit EQU 6
logSendData EQU 7
logSendControlData EQU 8
logAutoSetup EQU 9
logDataEnd EQU 10
logInA0Start EQU 11
logOutA0Start EQU 12
logHostInit EQU 13
logKillDevice EQU 14
logKillDriver EQU 15
logSetupLog EQU 16
logInData EQU 17
logCallBack EQU 18
logError EQU 19
logSetPortFeature EQU 20
logClearPortFeature EQU 21
logGetDeviceStatus EQU 22
logSetHubFeature EQU 23
logClearHubFeature EQU 24
logGetHubStatus EQU 25
logGetHubPortStatus EQU 26
logSetAddress EQU 27
logLogDone EQU 28
logDataStart EQU 29
logCustom EQU 30
 ~

LogStringTable:
       dw     lsLogError
       dw     lsGetMaxPacketSize
       dw     lsData
       dw     lsGetClass
       dw     lsGetIDs
       dw     lsReadDescriptor
       dw     lsQuit
       dw     lsSendData
       dw     lsSendControlData
       dw     lsAutoSetup
       dw     lsDataEnd
       dw     lsInA0Start
       dw     lsOutA0Start
       dw     lsHostInit
       dw     lsKillDevice
       dw     lsKillDriver
       dw     lsSetupLog
       dw     lsInData
       dw     lsCallBack
       dw     lsError
       dw     lsSetPortFeature
       dw     lsClearPortFeature
       dw     lsGetDeviceStatus
       dw     lsSetHubFeature
       dw     lsClearHubFeature
       dw     lsGetHubStatus
       dw     lsGetHubPortStatus
       dw     lsSetAddress
       dw     lsLogDone
       dw     lsLogDataStart
       dw     lsLogCustom
       dw     lsLogInterrupt
       dw     lsLogKBDInit
       dw     lsLogKBDGetKey
       dw     lsLogMSDInit
       dw     lsLogUFIInit
       dw     lsLogFATInit
       dw     lsLogPadInit
       dw     lsLogPadStart
       dw     lsLogPadSetup
       dw     lsLogPadCallBack
NumLogVals EQU ($-LogStringTable)/2
lsGetMaxPacketSize:  db     "GetMaxPack",0
lsData:              db     "Data",0
lsGetClass:          db     "GetClass",0
lsGetIDs:            db     "GetIDs",0
lsReadDescriptor     db     "ReadDesc",0
lsQuit:              db     "Quit",0
lsSendData:          db     "SendData",0
lsSendControlData    db     "SndConData",0
lsAutoSetup          db     "AutoSetup",0
lsDataEnd            db     "DataEnd",0
lsInA0Start          db     "InA0Start",0
lsOutA0Start         db     "OutA0Start",0
lsHostInit           db     "HostInit",0
lsKillDevice         db     "KillDevice",0
lsKillDriver         db     "KillDriver",0
lsSetupLog           db     "SetupLog",0
lsInData             db     "InData",0
lsCallBack           db     "CallBack",0
lsError              db     "Error",0
lsSetPortFeature     db     "SetPrtFeat",0
lsClearPortFeature   db     "ClrPrtFeat",0
lsGetDeviceStatus    db     "GetDevStat",0
lsSetHubFeature      db     "SetHubFeat",0
lsClearHubFeature    db     "ClrHubFeat",0
lsGetHubStatus       db     "GetHubStat",0
lsGetHubPortStatus   db     "GetPrtStat",0
lsSetAddress         db     "SetAddress",0
lsLogDone            db     "LogDone",0
lsLogDataStart       db     "Data",0
lsLogCustom          db     "Custom",0
lsLogInterrupt       db     "Interrupt",0
lsLogKBDInit         db     "KBDInit",0
lsLogKBDGetKey       db     "KBDGetKey",0
lsLogMSDInit         db     "MSDInit",0
lsLogUFIInit         db     "UFIInit",0
lsLogFATInit         db     "FATInit",0
lsLogPadInit         db     "PadInit",0
lsLogPadStart        db     "PadStart",0
lsLogPadSetup        db     "PadSetup",0
lsLogPadCallBack     db     "PadCB",0

lsLogError           db     "LOG ERROR",0

LogPageTXT:
       db     "Log Page:",0
LogAddrTXT:
       db     "Log Addr:",0
