 include "settings.inc"
  include "../ti83plus.inc"
  include "usb8x.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON
 EXTERN DoMenu
 EXTERN IPutS,IGetKey,DispHexHL,DispHexA,IPutC,IPutSUnicode,GetHexA,DispError






 Var VIDString,128
 Var PIDString,128
 Var SNString,32









DescriptorTool:
       ld     hl,DBuf
       ld     bc,256
       B_CALL MemClear
       ld     a,menuDescriptors
       jp     DoMenu


DescriptorError:
       U_CALL HostKill
       call   DispError
       call   IGetKey
       jr     DescriptorTool

DispStringDescriptor:
       U_CALL HostInit
       jr     c,DescriptorError
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,DescNumTXT
       call   IPutS
       call   GetHexA
       ld     c,a
       ld     b,descString
       ld     hl,DBuf
       U_CALL ReadDescriptor
       jr     c,DescriptorError
       ld     hl,DBuf
       call   IPutSUnicode
       call   IGetKey
       jr     DescriptorTool
DescNumTXT:
       db     "Desc Num: ",0

DispDeviceDescriptor:    
       U_CALL HostInit
       jr     c,DescriptorError
       ld     hl,DBuf
       ld     b,descDevice
       U_CALL ReadDescriptor
       jr     c,DescriptorError

       B_CALL ClrLCDFull
       B_CALL HomeUp              
       ld     hl,DDVerTXT
       call   IPutS
       ld     a,(DBuf+3)
       call   DispHexA
       ld     a,'.'
       call   IPutC
       ld     a,(DBuf+2)
       call   DispHexA
       B_CALL NewLine
       ld     hl,DDClassTXT
       call   IPutS
       ld     a,(DBuf+4)
       call   DispHexA
       B_CALL NewLine
       ld     hl,DDSubClassTXT
       call   IPutS
       ld     a,(DBuf+5)
       call   DispHexA
       B_CALL NewLine
       ld     hl,DDProtocolTXT
       call   IPutS
       ld     a,(DBuf+6)
       call   DispHexA
       B_CALL NewLine
       ld     hl,DDMaxPacketTXT
       call   IPutS
       ld     a,(DBuf+7)
       call   DispHexA
       B_CALL NewLine
       ld     hl,DDVendorIDTXT
       call   IPutS 
       ld     hl,(DBuf+8)
       call   DispHexHL
       B_CALL NewLine
       ld     hl,DDProductIDTXT
       call   IPutS
       ld     hl,(DBuf+10)
       call   DispHexHL
       B_CALL NewLine
       ld     hl,DDReleaseTXT
       call   IPutS
       ld     a,(DBuf+13)
       call   DispHexA
       ld     a,'.'
       call   IPutC
       ld     a,(DBuf+12)
       call   DispHexA
       call   IGetKey
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,DDNumConfigsTXT
       call   IPutS
       ld     a,(DBuf+17)
       call   DispHexA
       B_CALL NewLine
       call   IGetKey
       U_CALL HostKill
       jp     DescriptorTool

DDVendorIDTXT:
       db     "Vendor ID: ",0
DDProductIDTXT:
       db     "Prod ID: ",0
DDReleaseTXT:
       db     "Release: ",0
DDSubClassTXT:
SubClassTXT:
       db     "Sub Class: ",0
DDClassTXT:
ClassTXT:
       db     "Class: ",0
DDProtocolTXT:
ProtocolTXT:
       db     "Protocol: ",0
DDMaxPacketTXT:
MaxPacketTXT:
       db     "Max Packet: ",0
DDVerTXT:
       db     "USB Ver: ",0
DDNumConfigsTXT:
       db     "Configs: ",0
NumEndPointsTXT:
       db     "Endpoints: ",0
AlternateTXT:
       db     "Alternate: ",0
InterruptTXT:
       db     "Interrupt",0
BulkTXT:
       db     "Bulk",0
ControlTXT:
       db     "Control",0
IsochronousTXT:
       db     "Isochronous",0
InterfaceNumberTXT:
       db     "Int Number: ",0
InterfaceDTXT:
       db     "Interface Desc",0
EndpointDTXT:
       db     "Endpoint Desc",0
UnknownDTXT:
       db     "Unknown Desc",0
HIDDTXT:     
       db     "HID Desc",0
OTGDTXT:
       db     "OTG Desc",0
HNPTXT:
       db     "HNP Supported",0
SRPTXT:
       db     "SRP Supported",0
AddressTXT:
       db     "Address: ",0
IntervalTXT:
       db     "Interval: ",0
NumEndpointsTXT:
       db     "Num Endpnts: ",0
ConfigSetTXT:
       db     "Config Set",0
ConfigTXT:
       db     "Config: ",0
SizeTXT:
       db     "Size: ",0
CountryTXT:
       db     "Country: ",0
NumDescriptorsTXT:
       db     "Num Dscrptrs: ",0
ReportTypeTXT:
       db     "Report Type: ",0
ReportLengthTXT:
       db     "Report Len: ",0
HIDVersionTXT:
       db     "HID Ver: ",0


DispConfigDescriptor:
       U_CALL HostInit
       jr     c,DescriptorError
       ld     hl,DBuf
       ld     b,descConfig
       U_CALL ReadDescriptor
       jr     c,DescriptorError

       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,NumInterfacesTXT
       call   IPutS
       ld     a,(DBuf+4)
       call   DispHexA
       B_CALL NewLine
       ld     hl,ConfigValueTXT
       call   IPutS
       ld     a,(DBuf+5)
       call   DispHexA
       B_CALL NewLine
       ld     hl,SelfPoweredTXT
       ld     a,(DBuf+7)
       bit    6,a
       jr     nz,$f
       ld     hl,BusPoweredTXT
$$:
       call   IPutS
       B_CALL NewLine
       ld     hl,MaxPowerTXT
       call   IPutS
       ld     a,(DBuf+8)
       ld     l,a
       ld     h,0
       add    hl,hl
       B_CALL DispHL
       call   IGetKey
       call   DispOtherDescriptors

       U_CALL HostKill
       jr     DescriptorTool

ConfigValueTXT:
       db     "Cfg Value: ",0
NumInterfacesTXT:
       db     "Interfaces: ",0
SelfPoweredTXT:
       db     "Self Powered",0
BusPoweredTXT:
       db     "Bus Powered",0
MaxPowerTXT:
       db     "Max Power: ",0

DispOtherDescriptors:
;This will get and display other descriptors from the tail of the config descriptor
       ld     hl,DBuf
$$:
       call   NextDescriptor
       ret    z
       push   hl
       B_CALL ClrLCDFull
       B_CALL HomeUp
       pop    hl
       call   DispDescriptor
       call   IGetKey
       jr     $b

DispDescriptor:
       push   hl
       inc    hl
       ld     a,(hl)
       cp     descInterface
       jr     z,DispID
       cp     descEndpoint
       jr     z,DispED
       cp     descOnTheGo
       jr     z,DispOTGD
       cp     descHID
       jr     z,DispHIDD
DispOtherD:
       ld     hl,UnknownDTXT
       call   IPutS
       B_CALL NewLine
       pop    hl
       push   hl
       ld     b,(hl)
DispOtherDLoop:
       ld     a,(hl)
       call   DispHexA
       inc    hl
       djnz   DispOtherDLoop
       pop    hl
       ret
DispOTGD:
       push   hl
       ld     hl,OTGDTXT
       call   IPutS
       B_CALL NewLine
       pop    hl
       inc    hl
       ld     a,(hl)
       push   af
       bit    0,a
       jr     z,$f
       ld     hl,SRPTXT
       call   IPutS
       B_CALL NewLine
$$:
       pop    af
       bit    1,a
       jr     z,$f
       ld     hl,HNPTXT
       call   IPutS
       pop    hl
       ret

DispHIDD:
       push   hl
       ld     hl,HIDDTXT
       call   IPutS
       B_CALL NewLine
       ld     hl,HIDVersionTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       inc    hl
       ld     a,(hl)
       call   DispHexA
       ld     a,'.'
       call   IPutC
       pop    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,CountryTXT
       call   IPutS
       pop    hl
       inc    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,NumDescriptorsTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
;       B_CALL NewLine
       ld     hl,ReportTypeTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,ReportLengthTXT
       call   IPutS
       pop    hl
       inc    hl
       ld     a,(hl)
       call   DispHexA
       pop    hl
       ret
DispED:
       push   hl
       ld     hl,EndpointDTXT
       call   IPutS
       B_CALL NewLine

;       ld     hl,SizeTXT
;       call   IPutS
;       pop    hl
;       push   hl
;       dec    hl
;       ld     a,(hl)
;       call   DispHexA
;       B_CALL NewLine
       ld     hl,AddressTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispEndpointType
       ld     hl,MaxPacketTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,IntervalTXT
       call   IPutS
       pop    hl
       inc    hl
       inc    hl
       ld     a,(hl)
       call   DispHexA
       pop    hl
       ret
DispEndpointType:
       and    3
       or     a
       jr     nz,$f
       ld     hl,ControlTXT
$$:
       dec    a
       jr     nz,$f
       ld     hl,IsochronousTXT
$$:
       dec    a
       jr     nz,$f
       ld     hl,BulkTXT
$$:
       dec    a
       jr     nz,$f
       ld     hl,InterruptTXT
$$:
       call   IPutS
       B_CALL NewLine
;At this point we could display more specific isochronous info, except I'm too lazy.
       ret
DispID:
       push   hl
       ld     hl,InterfaceDTXT
       call   IPutS
       B_CALL NewLine
       ld     hl,InterfaceNumberTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,AlternateTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,NumEndpointsTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,ClassTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,SubClassTXT
       call   IPutS
       pop    hl
       inc    hl
       push   hl
       ld     a,(hl)
       call   DispHexA
       B_CALL NewLine
       ld     hl,ProtocolTXT
       call   IPutS
       pop    hl
       inc    hl
       ld     a,(hl)
       call   DispHexA
       pop    hl
       ret

NextDescriptor:
       ld     e,(hl)
       ld     d,0
       add    hl,de
       ld     a,(hl)
       or     a
       ret



