;USB Tools 0.01
; Initial version

 include "settings.inc"
  include "../ti83plus.inc"
  include "usb8x.inc"
 include "equates.inc" 
 include "header.asm"
 SEGMENT Main
 GLOBALS ON
 EXTERN DoMenu
 EXTERN IPutS,IGetKey,DispHexHL,DispHexA,IPutC,IPutSUnicode,GetHexA,DispError,KBDRAM


 Var DriverBuf,128
 Var USBDriverCall,32
 Var IIBuffer,48

Init:
       set    appAutoScroll,(iy+appFlags)
       U_CALL_INIT RetC
       jr     c,Usb8xNotLoaded
       U_CALL GetVersion
       ld     de,000B
       or     a
       sbc    hl,de
       jr     c,VersionError
       ld     hl,DriverBuf
       U_CALL DriverInit
       jr     c,VersionError
DispMainMenu:
       ld     a,menuMain
       jp     DoMenu


Stuff:
       ld     a,menuStuff
       jp     DoMenu

StuffError:
       call   DispError
       call   IGetKey
       jr     Stuff


Tools:
       ld     a,menuTools
       jp     DoMenu

KBDStuff:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,KBDStuffTXT
       call   IPutS
       call   IGetKey
       jr     Stuff
MouseStuff:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,MouseStuffTXT
       call   IPutS
       call   IGetKey
       jr     Stuff

KBDStuffTXT:
       db     "Alas.  Keyboard "
       db     "Action isn't yet"
       db     "implemented.",0
MouseStuffTXT:
       db     "Sadness.  Mouse "
       db     "Action isn't yet"
       db     "implemented.",0

 Var LoadedII,1

About:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,AboutTXT
       call   IPutS

       ld     de,IIBuffer
       push   de
       U_CALL InternalInfo
       pop    de
       ld     a,(de)
       inc    de
       push   de
       cp     NumII+1
       jr     c,$f
       ld     a,NumII
$$:
       ld     (LoadedII),a
       res    appAutoScroll,(iy+appFlags)
       ld     b,0

DispIILoop:
       push   bc
       ld     a,7
       and    b
       jr     nz,$f
       call   IGetKey
       B_CALL ClrLCDFull
       B_CALL HomeUp
$$:
       pop    bc
       ld     l,b
       ld     h,0
       ld     de,IISizeTab
       push   hl
       add    hl,de
       ld     a,(hl)               ;Number of bytes to display
       pop    hl
       ld     de,IIStringTab
       add    hl,hl
       add    hl,de
       push   bc
       push   af
       B_CALL LdHLInd
       call   IPutS
       ld     a,16
       pop    bc
       sub    b
       sub    b
       ld     (curCol),a
       pop    de                   ;Actually BC
       pop    hl
       ld     c,b
       ld     b,0
       add    hl,bc
       push   hl
       ld     b,c
DispDataLoop:
       dec    hl
       ld     a,(hl)
       call   DispHexA
       djnz   DispDataLoop

       push   de
       pop    bc
       inc    b
       ld     a,(LoadedII)
       cp     b
       jr     nz,DispIILoop
       pop    de
       call   IGetKey
       jr     DispMainMenu

IISizeTab:
       db     1
       db     1
       db     1
       db     1
       db     1
       db     1
       db     1       
       db     2
       db     2
       db     2
       db     2
       db     2
       db     2
       db     2
       db     2
       db     2
       db     2
       db     2
       db     2
NumII EQU $-IISizeTab
IIStringTab:
       dw     IINumEntryPointsTXT
       dw     IIFHandleLenTXT
       dw     IILoggingTXT
       dw     IIAssertTXT
       dw     IIIntMacTypeTXT
       dw     IISafetyIntTXT
       dw     IIAlwaysCancelTXT
       dw     IIUVersionTXT
       dw     IIKVersionTXT
       dw     IIMVersionTXT
       dw     IIPVersionTXT
       dw     IIDriverMemSizeTXT
       dw     IIKBDMemSizeTXT
       dw     IIMSDMemSizeTXT
       dw     IIPadMemSizeTXT
       dw     IIMouseMemSizeTXT
       dw     IIMSDBufferSizeTXT
       dw     IIMSDSectorSizeTXT
       dw     IIUSB8XSizeTXT
IINumEntryPointsTXT:
       db     "Entry Points",0
IIFHandleLenTXT:
       db     "FHand Length",0
IILoggingTXT:
       db     "Logging?",0
IIAssertTXT:
       db     "Assert?",0
IIIntMacTypeTXT:
       db     "Int Mac Type",0
IISafetyIntTXT:
       db     "Safety Int?",0
IIAlwaysCancelTXT:
       db     "Cancel Int?",0
IIUVersionTXT:
       db     "U Version",0
IIKVersionTXT:
       db     "K Version",0
IIMVersionTXT:
       db     "M Version",0
IIPVersionTXT:
       db     "P Version",0
IIDriverMemSizeTXT:
       db     "Driver Mem",0
IIKBDMemSizeTXT:
       db     "KBD Mem",0
IIMSDMemSizeTXT:
       db     "MSD Mem",0
IIPadMemSizeTXT:
       db     "Pad Mem",0
IIMouseMemSizeTXT:
       db     "Mouse Mem",0
IIMSDBufferSizeTXT:
       db     "MSD Buffer",0
IIMSDSectorSizeTXT:
       db     "MSD Sector",0
IIUSB8XSizeTXT:
       db     "usb8x Size",0

AboutTXT:
       db     "USB Tools 0.01  "
       db     "                "
       db     "Website:        "
       db     "http://usbtools."
       db     "denglend.net",0
RetC:
       scf
       ret

VersionError:
       ld     hl,BadVersionTXT
       jr     ErrorQuit
Usb8xNotLoaded:
       ld     hl,Nousb8xTXT
       jr     ErrorQuit
Nousb8xTXT:
BadVersionTXT:
       db     "USB Tools       "
       db     "requires version"
       db     "0.11 or higher  "
       db     "of usb8x and    "
       db     "version 2.30 or "
       db     "higher of TIOS",0


ErrorQuit:
       push   hl
       B_CALL ClrLCDFull
       B_CALL HomeUp
       pop    hl
       call   IPutS
       call   IGetKey
       B_JUMP JForceCmdNoChar

Quit:
       bit    appWantGetKey,(iy+sysHookFlg)
       jr     nz,$f
       U_CALL HostKill
       U_CALL DriverKill
$$:
       B_JUMP JForceCmdNoChar
