 include "settings.inc"
  include "../ti83plus.inc"
  include "usb8x.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON



DispError:
       B_CALL NewLine
       ld     hl,ErrorTXT
       call   IPutS
       U_CALL GetErrorCode
       ld     a,b
       call   DispHexA
       ld     a,c
       jp     DispHexA
ErrorTXT:
       db     "ERROR: ",0       

INewLine:
       push   bc
       push   de
       push   hl
       B_CALL NewLine
       pop    hl
       pop    de
       pop    bc
       ret

IGetKey:
       push   bc
       push   de
       push   hl
       res    onInterrupt,(iy+onFlags)
       B_CALL GetKey
       pop    hl
       pop    de
       pop    bc
       ret

IPutSUnicode:
;Display a unicode string descriptor:
       ld     b,(hl)
       inc    hl
       inc    hl
       dec    b
       dec    b
$$:
       ld     a,(hl)
       or     a
       call   nz,IPutC
       inc    hl
       djnz   $b
       ret

IPutS:
       ld     a,(hl)
       inc    hl
       or     a
       ret    z
       call   IPutC
       jr     IPutS

IPutC:
       push   hl
       push   bc
       B_CALL PutC
       pop    bc
       pop    hl
       ret
       
 Var TempNum,2
GetHexA:
		; lets user input an 8 bit number in hexadecimal
		; prompt is at currow,curcol
		; number is returned in a
	set	curAble,(iy+curFlags)
	ld	b,2
	ld	hl,TempNum
getnumhloop:
       call   IGetKey
	cp	2
	jp	nz,gnhnotback
	ld	a,b
	cp	2
	jp	z,gnhnotback
	ld	a,' '
       B_CALL PutMap
	ld	hl,curCol
	dec	(hl)
	jp	GetHexA

gnhnotback:
	sub	142
	cp	10
	jp	c,gnhnumpressed
	sub	12
	cp	6
	jp	c,gnhletpressed
	jp	getnumhloop
gnhnumpressed:
	ld	(hl),a
	inc	hl
	add	a,48
	call	IPutC
	djnz	getnumhloop
	jp	gnhdone
gnhletpressed:
	add	a,10
	ld	(hl),a
	inc	hl
	add	a,55
       call   IPutC
	djnz	getnumhloop
gnhdone:
	dec	hl
	ld	b,(hl)
	dec	hl
	ld	a,(hl)
	rlca
	rlca
	rlca
	rlca
	or	b
       res    curAble,(iy+curFlags)
	ret

DispHexHL:
       push   af
       ld     a,h
       call   DispHexA
       ld     a,l
       call   DispHexA
       pop    af
       ret

DispHexA:
	push	af
        push    hl
        push    bc
        push    af
        rrca
        rrca
        rrca
        rrca
        call    dispha
        pop     af
        call      dispha
        pop     bc
        pop     hl
	pop	af
        ret
dispha:
        and     15
        cp      10
        jp      nc,dhlet
        add     a,48
        jp      dispdh
dhlet:
        add     a,55
dispdh:
       call   IPutC
        ret




PutSprite:
;ix -> sprite
;b = height
;a = x coord
;l = y coord
       ld     b,8
       ld     d,0
       ld     e,l
       ld     h,d
       add    hl,hl
       add    hl,hl
       add    hl,de
       add    hl,de
       add    hl,hl         ;y coord *12 offset to first row
       ld     e,a
       srl    e
       srl    e
       srl    e             ;x coord byte offset
       add    hl,de         ;offset to start of byte
       ld     de,plotSScreen
       add    hl,de
       and    7             ;number of bits to rotate
       ld     c,a
PutSpriteLoop:
       ld     a,c           ;bits to shift
       ld     d,0           ;2nd byte to load
       ld     e,(ix)        ;1st byte to load
       or     a
       jr     z,NoShift
$$:
       srl    e
       rr     d
       dec    a
       jr     nz,$b
NoShift:
       ld     a,(hl)
       xor    e
       ld     (hl),a
       inc    hl
       ld     a,(hl)
       xor    d
       ld     (hl),a
       ld     de,11
       add    hl,de
       inc    ix
       djnz   PutSpriteLoop
       ret



WaitTimer32:
       call   WaitTimer16
WaitTimer16:
       call   WaitTimer8
WaitTimer8:
       call   WaitTimer4
WaitTimer4:
       call   WaitTimer2
WaitTimer2:
       call   WaitTimer1
WaitTimer1:
;Waits for about 10ms?
	ld	a,42h
	out	(36h),a
	xor	a
	out	(37h),a
	ld	a,1
	out	(38h),a
$$:
	in	a,(4)
	bit	7,a
	jr	z,$b
       or     a
	ret
